package graphs;

/**
 * Visitor to a vertex of a graph (IVertex)
 */
public interface IVertexAlgo {
  /**
   * Parameterized case method.
   * @param nNhbrs the number of neighbors (IVertexs) the host has
   * @param host the IVertex host
   * @params variable number of input parameters
   * @return the result of the calculation
   */
  public Object caseAt(int nNhbrs, IVertex host, Object...fns);
}